#!///usr/local/bin/munger

; Copyright (c) 2001, 2002, 2003, James Bailie <jimmy@mammothcheese.ca>.
; All rights reserved.
; 
; Redistribution and use in source form, with or without
; modification, are permitted provided that the following conditions are met:
; 
;     * Redistributions of source code must retain the above copyright
; notice, this list of conditions and the following disclaimer.
;     * The name of James Bailie may not be used to endorse or promote 
; products derived from this software without specific prior written permission.
; 
; THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS "AS IS"
; AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
; IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
; ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
; LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
; CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
; SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
; INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
; CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
; ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
; POSSIBILITY OF SUCH DAMAGE.

; This is a sample CGI script, intended to be invoked with the GET method.
; It converts the x-www-form-urlencoded query string, and sends it back to
; the user with some of the other environment data set by the server.

; Make errors fatal.

(fatal)

; Load CGI helper functions.

(load (join "/" (libdir) "cgi.munger"))

(defun send_page ()

   (get_data)

   (let ((query (getenv "QUERY_STRING"))
         (server (getenv "SERVER_NAME"))
         (port (getenv "SERVER_PORT"))
         (software (getenv "SERVER_SOFTWARE"))
         (protocol (getenv "SERVER_PROTOCOL"))
         (interface (getenv "GATEWAY_INTERFACE"))
         (agent (getenv "HTTP_USER_AGENT"))
         (addr (getenv "REMOTE_ADDR")))

      (send_headers "CGI Test" "" "" "" "")

      (print "<h1>Server:</h1><pre>")
      (newline)
      (print "Server Hostname:   " server "<br/>")
      (newline)
      (print "Listening On Port: " port "<br/>")
      (newline)
      (print "Running:           " software "<br/>")
      (newline)
      (print "Using Protocol:    " protocol "<br/>")
      (newline)
      (print "CGI Revision:      " interface "</pre>")
      (newline)

      (print "<h1>Client:</h1><pre>")
      (newline)
      (print "Client Address:    " addr "<br/>")
      (newline)
      (print "Client Agent:      " agent "</pre>")
      (newline)

      (print "<h1>Query:</h1><pre>")
      (newline)

      (foreach (lambda (key)
                  (let ((val (lookup data key)))
                     (print "Query pair:        " key " = "
                        (if (eq "" val) "(not set)" val) "<br/>")
                     (newline)))
               (keys data))

      (print "</pre></body></html>")
      (newline)))

(send_page)
(quit)
